/* ------------------------------------------------------------------
 * Un exemple d'implmentation du cache d'un fichier afin d'explorer
 * l'effet des algorithmes de gestion et de remplacement
 * ------------------------------------------------------------------
 * Jean-Paul Rigault --- ESSI --- Janvier 2005
 * ------------------------------------------------------------------
 * Une liste simple de blocs du cache : spcification
 * ------------------------------------------------------------------
 */

#ifndef _CACHE_LIST_
#define _CACHE_LIST_

/* La cellule de liste doublement chaine */
struct Cache_List
{
    struct Cache_Block_Header *pheader;	/* information */
    struct Cache_List *next;		/* chainage avant */
    struct Cache_List *prev;		/* chainage arrire */

};

/* Cration et destruction */
struct Cache_List *Cache_List_Create();
void Cache_List_Delete(struct Cache_List *list);

/* Insertion d'un lment au dbut et  la fin */
void Cache_List_Append(struct Cache_List *list, struct Cache_Block_Header *pbh);
void Cache_List_Prepend(struct Cache_List *list, struct Cache_Block_Header *pbh);

/* Retrait du premier, du dernier ou d'un quelconque lment */
struct Cache_Block_Header *Cache_List_Remove_First(struct Cache_List *list);
struct Cache_Block_Header *Cache_List_Remove_Last(struct Cache_List *list);
struct Cache_Block_Header *Cache_List_Remove(struct Cache_List *list,
                                             struct Cache_Block_Header *pbh);

/* Remise en l'tat de liste vide */
void Cache_List_Clear(struct Cache_List *list);

/* Test de liste vide */
int Cache_List_Is_Empty(struct Cache_List *list);

/* Transfrer un lment  la fin ou au dbut */
void Cache_List_Move_To_End(struct Cache_List *list,
                            struct Cache_Block_Header *pbh);
void Cache_List_Move_To_Begin(struct Cache_List *list,
                              struct Cache_Block_Header *pbh);

#endif /* CACHE_LIST_ */
