/* ------------------------------------------------------------------
 * Un exemple d'implmentation du cache d'un fichier afin d'explorer
 * l'effet des algorithmes de gestion et de remplacement
 * ------------------------------------------------------------------
 * Jean-Paul Rigault --- ESSI --- Janvier 2005
 * ------------------------------------------------------------------
 * Interface(abstraite) de la stratgie des gestion/remplacement
 * ------------------------------------------------------------------
 */

#ifndef _STRATEGY_H_
#define _STRATEGY_H_

struct Cache;
struct Cache_Block_Header;

/* Creation et initialisation de la stratgie (invoqu par la cration de cache) */
void *Strategy_Create(struct Cache *pcache);

/* Fermeture de la stratgie */
void Strategy_Close(struct Cache *pcache);

/* Fonction "rflexe" lors de l'invalidation du cache */
void Strategy_Invalidate(struct Cache *pcache);

/* Algorithme de remplacement de bloc */
struct Cache_Block_Header *Strategy_Replace_Block(struct Cache *pcache);

/* Fonctions "rflexes" lors de la lecture et de l'criture */
void Strategy_Read(struct Cache *pcache, struct Cache_Block_Header *pb);
void Strategy_Write(struct Cache *pcache, struct Cache_Block_Header *pb);

/* Identification de la stratgie */
char *Strategy_Name();

#endif /* _STRATEGY_H_ */
